Index: pjproject/trunk/pjlib/src/pj/config.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/config.c	(revision 562)
+++ pjproject/trunk/pjlib/src/pj/config.c	(revision 563)
@@ -22,5 +22,5 @@
 
 static const char *id = "config.c";
-const char *PJ_VERSION = "0.5.6.0";
+const char *PJ_VERSION = "0.5.6.1";
 
 PJ_DEF(void) pj_dump_config(void)
Index: pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 562)
+++ pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 563)
@@ -30,4 +30,6 @@
     pjsua_logging_config    log_cfg;
     pjsua_media_config	    media_cfg;
+    pj_bool_t		    no_tcp;
+    pj_bool_t		    no_udp;
     pjsua_transport_config  udp_cfg;
     pjsua_transport_config  rtp_cfg;
@@ -96,5 +98,9 @@
     puts  ("");
     puts  ("Transport Options:");
-    puts  ("  --local-port=port   Set TCP/UDP port");
+    puts  ("  --local-port=port   Set TCP/UDP port. This implicitly enables both ");
+    puts  ("                      TCP and UDP transports on the specified port, unless");
+    puts  ("                      if TCP or UDP is disabled.");
+    puts  ("  --no-tcp            Disable TCP transport.");
+    puts  ("  --no-udp            Disable UDP transport.");
     puts  ("  --outbound=url      Set the URL of global outbound proxy server");
     puts  ("                      May be specified multiple times");
@@ -240,5 +246,5 @@
 	   OPT_COMPLEXITY, OPT_QUALITY, OPT_PTIME,
 	   OPT_NEXT_ACCOUNT, OPT_NEXT_CRED, OPT_MAX_CALLS, 
-	   OPT_DURATION,
+	   OPT_DURATION, OPT_NO_TCP, OPT_NO_UDP,
     };
     struct pj_getopt_option long_options[] = {
@@ -252,4 +258,6 @@
 	{ "null-audio", 0, 0, OPT_NULL_AUDIO},
 	{ "local-port", 1, 0, OPT_LOCAL_PORT},
+	{ "no-tcp",     0, 0, OPT_NO_TCP},
+	{ "no-udp",     0, 0, OPT_NO_UDP},
 	{ "proxy",	1, 0, OPT_PROXY},
 	{ "outbound",	1, 0, OPT_OUTBOUND_PROXY},
@@ -385,4 +393,22 @@
 	    break;
 
+	case OPT_NO_UDP: /* no-udp */
+	    if (cfg->no_tcp) {
+	      PJ_LOG(1,(THIS_FILE,"Error: can not disable both TCP and UDP"));
+	      return PJ_EINVAL;
+	    }
+
+	    cfg->no_udp = PJ_TRUE;
+	    break;
+
+	case OPT_NO_TCP: /* no-tcp */
+	    if (cfg->no_udp) {
+	      PJ_LOG(1,(THIS_FILE,"Error: can not disable both TCP and UDP"));
+	      return PJ_EINVAL;
+	    }
+
+	    cfg->no_tcp = PJ_TRUE;
+	    break;
+
 	case OPT_PROXY:   /* proxy */
 	    if (pjsua_verify_sip_url(pj_optarg) != 0) {
@@ -2047,5 +2073,5 @@
 pj_status_t app_init(int argc, char *argv[])
 {
-    pjsua_transport_id transport_id;
+    pjsua_transport_id transport_id = -1;
     unsigned i;
     pj_status_t status;
@@ -2097,14 +2123,38 @@
     }
 
-    /* Add UDP transport */
-    status = pjsua_transport_create(PJSIP_TRANSPORT_UDP,
-				    &app_config.udp_cfg, 
-				    &transport_id);
-    if (status != PJ_SUCCESS)
+
+    /* Add TCP transport unless it's disabled */
+    if (!app_config.no_tcp) {
+	status = pjsua_transport_create(PJSIP_TRANSPORT_TCP,
+					&app_config.udp_cfg, 
+					&transport_id);
+	if (status != PJ_SUCCESS)
+	    goto on_error;
+
+	/* Add local account */
+	pjsua_acc_add_local(transport_id, PJ_TRUE, &current_acc);
+	pjsua_acc_set_online_status(current_acc, PJ_TRUE);
+
+    }
+
+
+    /* Add UDP transport unless it's disabled. */
+    if (!app_config.no_udp) {
+	status = pjsua_transport_create(PJSIP_TRANSPORT_UDP,
+					&app_config.udp_cfg, 
+					&transport_id);
+	if (status != PJ_SUCCESS)
+	    goto on_error;
+
+	/* Add local account */
+	pjsua_acc_add_local(transport_id, PJ_TRUE, &current_acc);
+	pjsua_acc_set_online_status(current_acc, PJ_TRUE);
+    }
+
+    if (transport_id == -1) {
+	PJ_LOG(3,(THIS_FILE, "Error: no transport is configured"));
+	status = -1;
 	goto on_error;
-
-    /* Add local account */
-    pjsua_acc_add_local(transport_id, PJ_TRUE, &current_acc);
-    pjsua_acc_set_online_status(current_acc, PJ_TRUE);
+    }
 
 
Index: pjproject/trunk/pjsip/build/Makefile
===================================================================
--- pjproject/trunk/pjsip/build/Makefile	(revision 562)
+++ pjproject/trunk/pjsip/build/Makefile	(revision 563)
@@ -26,5 +26,4 @@
 		   $(subst /,$(HOST_PSEP),$(PJSIP_SIMPLE_LIB)) \
 		   $(subst /,$(HOST_PSEP),$(PJSIP_LIB)) \
-		   $(subst /,$(HOST_PSEP),$(PJMEDIA_CODEC_LIB)) \
 		   $(subst /,$(HOST_PSEP),$(PJMEDIA_LIB)) \
 		   $(subst /,$(HOST_PSEP),$(PJLIB_UTIL_LIB)) \
@@ -41,6 +40,8 @@
 		sip_errno.o sip_msg.o sip_parser.o sip_tel_uri.o sip_uri.o \
 		sip_endpoint.o sip_util.o sip_util_proxy.o \
-		sip_resolve.o sip_transport.o sip_transport_loop.o sip_transport_udp.o \
-		sip_auth_client.o sip_auth_msg.o sip_auth_parser.o sip_auth_server.o \
+		sip_resolve.o sip_transport.o sip_transport_loop.o \
+		sip_transport_udp.o sip_transport_tcp.o \
+		sip_auth_client.o sip_auth_msg.o sip_auth_parser.o \
+		sip_auth_server.o \
 		sip_transaction.o sip_util_statefull.o \
 		sip_dialog.o sip_ua_layer.o
@@ -77,9 +78,26 @@
 
 export CC_OUT CC AR RANLIB HOST_MV HOST_RM HOST_RMDIR HOST_MKDIR OBJEXT LD LDOUT 
+
+###############################################################################
+# Defines for building test application
+#
+export TEST_SRCDIR = ../src/test-pjsip
+export TEST_OBJS += dlg_core_test.o msg_err_test.o msg_logger.o msg_test.o \
+		    test.o transport_loop_test.o transport_tcp_test.o \
+		    transport_test.o transport_udp_test.o \
+		    tsx_basic_test.o tsx_bench.o tsx_uac_test.o \
+		    tsx_uas_test.o txdata_test.o uri_test.o
+export TEST_OBJS += main.o
+export TEST_CFLAGS += $(_CFLAGS)
+export TEST_LDFLAGS += $(_LDFLAGS)
+export TEST_EXE := ../bin/pjsip-test-$(TARGET_NAME)$(HOST_EXE)
+
+	
+export CC_OUT CC AR RANLIB HOST_MV HOST_RM HOST_RMDIR HOST_MKDIR OBJEXT LD LDOUT 
 ###############################################################################
 # Main entry
 #
 #
-TARGETS := pjsip pjsip-ua pjsip-simple pjsua-lib
+TARGETS := pjsip pjsip-ua pjsip-simple pjsua-lib pjsip-test
 
 .PHONY: $(TARGETS)
@@ -106,4 +124,7 @@
 pjsua-lib: 
 	$(MAKE) -f $(RULES_MAK) APP=PJSUA_LIB app=pjsua-lib $(PJSUA_LIB_LIB)
+
+pjsip-test:
+	$(MAKE) -f $(RULES_MAK) APP=TEST app=pjsip-test $(TEST_EXE)
 
 .PHONY: ../lib/pjsip.ko
@@ -132,4 +153,5 @@
 	$(MAKE) -f $(RULES_MAK) APP=PJSIP_SIMPLE app=pjsip-simple $@
 	$(MAKE) -f $(RULES_MAK) APP=PJSUA_LIB app=pjsua-lib $@
+	$(MAKE) -f $(RULES_MAK) APP=TEST app=pjsip-test $@
 
 realclean:
@@ -141,4 +163,5 @@
 	$(MAKE) -f $(RULES_MAK) APP=PJSIP_UA app=pjsip-ua $@
 	$(MAKE) -f $(RULES_MAK) APP=PJSIP_SIMPLE app=pjsip-simple $@
+	$(MAKE) -f $(RULES_MAK) APP=TEST app=pjsip-test $@
 	$(MAKE) -f $(RULES_MAK) APP=PJSUA_LIB app=pjsua-lib $@
 
Index: pjproject/trunk/pjsip/build/test_pjsip.dsp
===================================================================
--- pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 562)
+++ pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 563)
@@ -118,4 +118,8 @@
 # Begin Source File
 
+SOURCE="..\src\test-pjsip\transport_tcp_test.c"
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\test-pjsip\transport_test.c"
 # End Source File
@@ -127,4 +131,8 @@
 
 SOURCE="..\src\test-pjsip\tsx_basic_test.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\test-pjsip\tsx_bench.c"
 # End Source File
 # Begin Source File
Index: pjproject/trunk/pjsip/include/pjsip.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip.h	(revision 562)
+++ pjproject/trunk/pjsip/include/pjsip.h	(revision 563)
@@ -40,4 +40,5 @@
 #include <pjsip/sip_transport_udp.h>
 #include <pjsip/sip_transport_loop.h>
+#include <pjsip/sip_transport_tcp.h>
 #include <pjsip/sip_resolve.h>
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 562)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 563)
@@ -705,5 +705,5 @@
 
     pjsip_transport_type_e  type;	    /**< Transport type.	*/
-    char		    type_name[8];   /**< Type string name.	*/
+    char		   *type_name;      /**< Type string name.	*/
     unsigned		    flag;	    /**< Transport flag.	*/
 
@@ -722,4 +722,9 @@
 				    int addr_len,
 				    pjsip_transport **transport);
+
+    /**
+     * Destroy the listener.
+     */
+    pj_status_t (*destroy)(pjsip_tpfactory *factory);
 
     /*
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport_tcp.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport_tcp.h	(revision 562)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport_tcp.h	(revision 563)
@@ -39,9 +39,33 @@
 
 /**
- * Create, register, and start TCP transport.
+ * The TCP incoming connection backlog number.
+ * Default: 5
+ */
+#ifndef PJSIP_TCP_TRANSPORT_BACKLOG
+#   define PJSIP_TCP_TRANSPORT_BACKLOG	5
+#endif
+
+
+/**
+ * Register support for SIP TCP transport by creating TCP listener on
+ * the specified address and port. This function will create an
+ * instance of SIP TCP transport factory and register it to the
+ * transport manager.
  *
  * @param endpt		The SIP endpoint.
- * @param local		Local address to bind.
- * @param async_cnt	Number of simultaneous async operations.
+ * @param local		Optional local address to bind, or specify the
+ *			address to bind the server socket to. Both IP 
+ *			interface address and port fields are optional.
+ *			If IP interface address is not specified, socket
+ *			will be bound to PJ_INADDR_ANY. If port is not
+ *			specified, socket will be bound to any port
+ *			selected by the operating system.
+ * @param async_cnt	Number of simultaneous asynchronous accept()
+ *			operations to be supported. It is recommended that
+ *			the number here corresponds to the number of
+ *			processors in the system (or the number of SIP
+ *			worker threads).
+ * @param p_factory	Optional pointer to receive the instance of the
+ *			SIP TCP transport factory just created.
  *
  * @return		PJ_SUCCESS when the transport has been successfully
@@ -51,5 +75,6 @@
 PJ_DECL(pj_status_t) pjsip_tcp_transport_start(pjsip_endpoint *endpt,
 					       const pj_sockaddr_in *local,
-					       unsigned async_cnt);
+					       unsigned async_cnt,
+					       pjsip_tpfactory **p_factory);
 
 
Index: pjproject/trunk/pjsip/include/pjsua-lib/pjsua_internal.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsua-lib/pjsua_internal.h	(revision 562)
+++ pjproject/trunk/pjsip/include/pjsua-lib/pjsua_internal.h	(revision 563)
@@ -105,6 +105,14 @@
 typedef struct transport_data
 {
-    int			 index;
-    pjsip_transport	*tp;
+    int			     index;
+    pjsip_transport_type_e   type;
+    pjsip_host_port	     local_name;
+
+    union {
+	pjsip_transport	    *tp;
+	pjsip_tpfactory	    *factory;
+	void		    *ptr;
+    } data;
+
 } transport_data;
 
Index: pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 562)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 563)
@@ -1300,4 +1300,5 @@
 	pj_memcpy(&tsx->addr, &tsx->res_addr.addr, tsx->res_addr.addr_len);
 	tsx->addr_len = tsx->res_addr.addr_len;
+	tsx->is_reliable = PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport);
     }
 
@@ -2131,7 +2132,23 @@
 	    }
 
-	    /* Start timer H for transaction termination */
-	    pjsip_endpt_schedule_timer(tsx->endpt,&tsx->timeout_timer,
-                                       &timeout_timer_val);
+	    /* For INVITE, start timer H for transaction termination 
+	     * regardless whether transport is reliable or not.
+	     * For non-INVITE, start timer J with the value of 64*T1 for
+	     * non-reliable transports, and zero for reliable transports.
+	     */
+	    if (tsx->method.id == PJSIP_INVITE_METHOD) {
+		/* Start timer H for INVITE */
+		pjsip_endpt_schedule_timer(tsx->endpt,&tsx->timeout_timer,
+					   &timeout_timer_val);
+	    } else if (!tsx->is_reliable) {
+		/* Start timer J on 64*T1 seconds for non-INVITE */
+		pjsip_endpt_schedule_timer(tsx->endpt,&tsx->timeout_timer,
+					   &timeout_timer_val);
+	    } else {
+		/* Start timer J on zero seconds for non-INVITE */
+		pj_time_val zero_time = { 0, 0 };
+		pjsip_endpt_schedule_timer(tsx->endpt,&tsx->timeout_timer,
+					   &zero_time);
+	    }
 
 	    /* For INVITE, if unreliable transport is used, retransmission 
Index: pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 562)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 563)
@@ -37,4 +37,10 @@
 #define THIS_FILE    "sip_transport.c"
 
+#if 0
+#   define TRACE_(x)	PJ_LOG(5,x)
+#else
+#   define TRACE_(x)
+#endif
+
 /* Prototype. */
 static pj_status_t mod_on_tx_msg(pjsip_tx_data *tdata);
@@ -602,4 +608,10 @@
     pj_lock_release(mgr->lock);
 
+    TRACE_((THIS_FILE,"Transport %s registered: type=%s, remote=%s:%d",
+		       tp->obj_name,
+		       pjsip_transport_get_type_name(tp->key.type),
+		       pj_inet_ntoa(((pj_sockaddr_in*)&tp->key.rem_addr)->sin_addr),
+		       pj_ntohs(((pj_sockaddr_in*)&tp->key.rem_addr)->sin_port)));
+
     return PJ_SUCCESS;
 }
@@ -610,4 +622,6 @@
 {
     int key_len;
+
+    TRACE_((THIS_FILE, "Transport %s is being destroyed", tp->obj_name));
 
     pj_lock_acquire(tp->lock);
@@ -627,4 +641,5 @@
      */
     key_len = sizeof(tp->key.type) + tp->addr_len;
+    pj_assert(pj_hash_get(mgr->table, &tp->key, key_len, NULL) != NULL);
     pj_hash_set(tp->pool, mgr->table, &tp->key, key_len, 0, NULL);
 
@@ -643,4 +658,6 @@
     pjsip_tpmgr *mgr;
     pj_status_t status;
+
+    TRACE_((THIS_FILE, "Transport %s shutting down", tp->obj_name));
 
     pj_lock_acquire(tp->lock);
@@ -808,4 +825,5 @@
     pj_hash_iterator_t itr_val;
     pj_hash_iterator_t *itr;
+    pjsip_tpfactory *factory;
     pjsip_endpoint *endpt = mgr->endpt;
     
@@ -814,4 +832,7 @@
     pj_lock_acquire(mgr->lock);
 
+    /*
+     * Destroy all transports.
+     */
     itr = pj_hash_first(mgr->table, &itr_val);
     while (itr != NULL) {
@@ -828,4 +849,16 @@
     }
 
+    /*
+     * Destroy all factories/listeners.
+     */
+    factory = mgr->factory_list.next;
+    while (factory != &mgr->factory_list) {
+	pjsip_tpfactory *next = factory->next;
+	
+	factory->destroy(factory);
+
+	factory = next;
+    }
+
     pj_lock_release(mgr->lock);
     pj_lock_destroy(mgr->lock);
@@ -843,5 +876,5 @@
     //pj_assert(pj_atomic_get(mgr->tdata_counter) == 0);
     if (pj_atomic_get(mgr->tdata_counter) != 0) {
-	PJ_LOG(4,(THIS_FILE, "Warning: %d transmit buffers are not freed!",
+	PJ_LOG(3,(THIS_FILE, "Warning: %d transmit buffer(s) not freed!",
 		  pj_atomic_get(mgr->tdata_counter)));
     }
@@ -880,8 +913,8 @@
 
     /* Process all message fragments. */
-    while (total_processed < remaining_len) {
+    while (remaining_len > 0) {
 
 	pjsip_msg *msg;
-	pj_size_t msg_fragment_size = 0;
+	pj_size_t msg_fragment_size;
 
 	/* Initialize default fragment size. */
@@ -1039,4 +1072,9 @@
     pj_status_t status;
 
+    TRACE_((THIS_FILE,"Acquiring transport type=%s, remote=%s:%d",
+		       pjsip_transport_get_type_name(type),
+		       pj_inet_ntoa(((pj_sockaddr_in*)remote)->sin_addr),
+		       pj_ntohs(((pj_sockaddr_in*)remote)->sin_port)));
+
     pj_lock_acquire(mgr->lock);
 
@@ -1084,4 +1122,6 @@
 	pj_lock_release(mgr->lock);
 	*tp = transport;
+
+	TRACE_((THIS_FILE, "Transport %s acquired", transport->obj_name));
 	return PJ_SUCCESS;
     }
@@ -1101,6 +1141,10 @@
 	/* No factory can create the transport! */
 	pj_lock_release(mgr->lock);
+	TRACE_((THIS_FILE, "No suitable factory was found either"));
 	return PJSIP_EUNSUPTRANSPORT;
     }
+
+    TRACE_((THIS_FILE, "%s, creating new one from factory",
+	   (transport?"Transport is shutdown":"No transport found")));
 
     /* Request factory to create transport. */
Index: pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c	(revision 562)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c	(revision 563)
@@ -74,5 +74,6 @@
 
     pool = pjsip_endpt_create_pool(loop->base.endpt, "rdata", 
-				   PJSIP_POOL_RDATA_LEN, PJSIP_POOL_RDATA_INC);
+				   PJSIP_POOL_RDATA_LEN, 
+				   PJSIP_POOL_RDATA_INC+5);
     if (!pool)
 	return NULL;
